diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/bindings/modulegen__gcc_ILP32.py ns-3.34/src/uan/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/uan/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
@@ -84,12 +84,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -735,8 +739,10 @@
     register_Ns3EventId_methods(root_module, root_module['ns3::EventId'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1831,6 +1837,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2044,6 +2062,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -2119,6 +2142,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2139,6 +2174,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -3751,6 +3791,11 @@
                    'void', 
                    [], 
                    is_pure_virtual=True, is_virtual=True)
+    ## uan-phy.h (module 'uan'): void ns3::UanPhyListener::NotifyTxEnd() [member function]
+    cls.add_method('NotifyTxEnd', 
+                   'void', 
+                   [], 
+                   is_pure_virtual=True, is_virtual=True)
     ## uan-phy.h (module 'uan'): void ns3::UanPhyListener::NotifyTxStart(ns3::Time duration) [member function]
     cls.add_method('NotifyTxStart', 
                    'void', 
@@ -5018,6 +5063,11 @@
                    'void', 
                    [], 
                    is_virtual=True)
+    ## uan-mac-cw.h (module 'uan'): void ns3::UanMacCw::NotifyTxEnd() [member function]
+    cls.add_method('NotifyTxEnd', 
+                   'void', 
+                   [], 
+                   is_virtual=True)
     ## uan-mac-cw.h (module 'uan'): void ns3::UanMacCw::NotifyTxStart(ns3::Time duration) [member function]
     cls.add_method('NotifyTxStart', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/bindings/modulegen__gcc_LP64.py ns-3.34/src/uan/bindings/modulegen__gcc_LP64.py
--- ns-3.33/src/uan/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
@@ -84,12 +84,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -735,8 +739,10 @@
     register_Ns3EventId_methods(root_module, root_module['ns3::EventId'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1831,6 +1837,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2044,6 +2062,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -2119,6 +2142,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2139,6 +2174,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -3751,6 +3791,11 @@
                    'void', 
                    [], 
                    is_pure_virtual=True, is_virtual=True)
+    ## uan-phy.h (module 'uan'): void ns3::UanPhyListener::NotifyTxEnd() [member function]
+    cls.add_method('NotifyTxEnd', 
+                   'void', 
+                   [], 
+                   is_pure_virtual=True, is_virtual=True)
     ## uan-phy.h (module 'uan'): void ns3::UanPhyListener::NotifyTxStart(ns3::Time duration) [member function]
     cls.add_method('NotifyTxStart', 
                    'void', 
@@ -5018,6 +5063,11 @@
                    'void', 
                    [], 
                    is_virtual=True)
+    ## uan-mac-cw.h (module 'uan'): void ns3::UanMacCw::NotifyTxEnd() [member function]
+    cls.add_method('NotifyTxEnd', 
+                   'void', 
+                   [], 
+                   is_virtual=True)
     ## uan-mac-cw.h (module 'uan'): void ns3::UanMacCw::NotifyTxStart(ns3::Time duration) [member function]
     cls.add_method('NotifyTxStart', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-header-common.h ns-3.34/src/uan/model/uan-header-common.h
--- ns-3.33/src/uan/model/uan-header-common.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-header-common.h	2021-07-14 10:31:07.000000000 -0700
@@ -28,10 +28,15 @@
 
 namespace ns3 {
 
+/**
+ * \ingroup uan
+ *
+ *  UAN protocol descriptor
+ */
 struct UanProtocolBits
 {
-  uint8_t  m_type : 4;
-  uint8_t  m_protocolNumber : 4;
+  uint8_t  m_type : 4;            //!< type (4 bits)
+  uint8_t  m_protocolNumber : 4;  //!< protocol number (4 bits)
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-mac-cw.cc ns-3.34/src/uan/model/uan-mac-cw.cc
--- ns-3.33/src/uan/model/uan-mac-cw.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-mac-cw.cc	2021-07-14 10:31:07.000000000 -0700
@@ -35,10 +35,11 @@
 
 UanMacCw::UanMacCw ()
   : UanMac (),
-    m_phy (0),
-    m_pktTx (0),
-    m_state (IDLE),
-    m_cleared (false)
+  m_phy (0),
+  m_pktTx (0),
+  m_txOngoing (false),
+  m_state (IDLE),
+  m_cleared (false)
 
 {
   m_rv = CreateObject<UniformRandomVariable> ();
@@ -63,7 +64,7 @@
       m_phy = 0;
     }
   m_sendEvent.Cancel ();
-  m_txEndEvent.Cancel ();
+  m_txOngoing = false;
 }
 
 void
@@ -115,7 +116,7 @@
     {
     case CCABUSY:
       NS_LOG_DEBUG ("Time " << Now ().As (Time::S) << " MAC " << GetAddress () << " Starting enqueue CCABUSY");
-      if (m_txEndEvent.IsRunning ())
+      if (m_txOngoing == true)
         {
           NS_LOG_DEBUG ("State is TX");
         }
@@ -254,22 +255,24 @@
 void
 UanMacCw::NotifyTxStart (Time duration)
 {
+  m_txOngoing = true;
 
-  if (m_txEndEvent.IsRunning ())
-    {
-      Simulator::Cancel (m_txEndEvent);
-    }
+  NS_LOG_DEBUG ("Time " << Now ().As (Time::S) << " Tx Start Notified");
 
-  m_txEndEvent = Simulator::Schedule (duration, &UanMacCw::EndTx, this);
-  NS_LOG_DEBUG ("Time " << Now ().As (Time::S) << " scheduling TxEndEvent with delay " << duration.As (Time::S));
   if (m_state == RUNNING)
     {
       NS_ASSERT (0);
       m_state = CCABUSY;
       SaveTimer ();
-
     }
+}
+
+void
+UanMacCw::NotifyTxEnd (void)
+{
+  m_txOngoing = false;
 
+  EndTx ();
 }
 
 int64_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-mac-cw.h ns-3.34/src/uan/model/uan-mac-cw.h
--- ns-3.33/src/uan/model/uan-mac-cw.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-mac-cw.h	2021-07-14 10:31:07.000000000 -0700
@@ -59,7 +59,7 @@
 
   /**
    * Set the contention window size.
-   *   
+   *
    * \param cw Contention window size.
    */
   virtual void SetCw (uint32_t cw);
@@ -96,6 +96,7 @@
   virtual void NotifyCcaStart (void);
   virtual void NotifyCcaEnd (void);
   virtual void NotifyTxStart (Time duration);
+  virtual void NotifyTxEnd (void);
 
   /**
    *  TracedCallback signature for enqueue/dequeue of a packet.
@@ -103,12 +104,12 @@
    * \param [in] packet The Packet being received.
    * \param [in] proto The protocol number.
    */
-  typedef void (* QueueTracedCallback)
-    (Ptr<const Packet> packet, uint16_t proto);
+  typedef void (* QueueTracedCallback)(Ptr<const Packet> packet, uint16_t proto);
 
 private:
   /** Enum defining possible Phy states. */
-  typedef enum {
+  typedef enum
+  {
     IDLE,     //!< Idle state.
     CCABUSY,  //!< Channel busy.
     RUNNING,  //!< Delay timer running.
@@ -141,8 +142,8 @@
   uint16_t m_pktTxProt;
   /** Scheduled SendPacket event. */
   EventId m_sendEvent;
-  /** Scheduled EndTx event. */
-  EventId m_txEndEvent;
+  /** Tx is ongoing */
+  bool m_txOngoing;
   /** Current state. */
   State m_state;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-mac.h ns-3.34/src/uan/model/uan-mac.h
--- ns-3.33/src/uan/model/uan-mac.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-mac.h	2021-07-14 10:31:07.000000000 -0700
@@ -128,7 +128,16 @@
   typedef void (* PacketModeTracedCallback)
     (Ptr<const Packet> packet, UanTxMode mode);
 
+  /**
+   * Get the Tx mode index (Modulation type).
+   * \return the Tx mode index
+   */
   uint32_t GetTxModeIndex ();
+
+  /**
+   * Set the Tx mode index (Modulation type).
+   * \param txModeIndex the Tx mode index
+   */
   void SetTxModeIndex (uint32_t txModeIndex);
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-mac-rc-gw.cc ns-3.34/src/uan/model/uan-mac-rc-gw.cc
--- ns-3.33/src/uan/model/uan-mac-rc-gw.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-mac-rc-gw.cc	2021-07-14 10:31:07.000000000 -0700
@@ -358,7 +358,7 @@
     {
       winSize = Seconds ((optA * std::exp (1.0) + 0.5) * 2.0 * 8.0 * m_rtsSize / (thAlpha * m_totalRate)) + (2 * m_maxDelta); 
     }
-  Time effWinSize = winSize - Seconds (m_rtsSize * 8 / ctlRate)  - (2 * m_maxDelta);
+  Time effWinSize = winSize - Seconds (m_rtsSize * 8.0 / ctlRate)  - (2 * m_maxDelta);
 
   // Before fast CTS/ACK(below)
   Time ctsTxTimeG = Seconds (m_ctsSizeG * 8.0 / dataRate);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-net-device.h ns-3.34/src/uan/model/uan-net-device.h
--- ns-3.33/src/uan/model/uan-net-device.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-net-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -146,7 +146,17 @@
   virtual bool SupportsSendFrom (void) const;
   virtual void AddLinkChangeCallback (Callback<void> callback);
   virtual void SetAddress (Address address);
+
+  /**
+   * Get the Tx mode index (Modulation type).
+   * \return the Tx mode index
+   */
   uint32_t GetTxModeIndex ();
+
+  /**
+   * Set the Tx mode index (Modulation type).
+   * \param txModeIndex the Tx mode index
+   */
   void SetTxModeIndex (uint32_t txModeIndex);
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-phy-gen.cc ns-3.34/src/uan/model/uan-phy-gen.cc
--- ns-3.33/src/uan/model/uan-phy-gen.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-phy-gen.cc	2021-07-14 10:31:07.000000000 -0700
@@ -149,7 +149,7 @@
       if (std::abs (pit->GetAmp ()) > maxAmp)
         {
           maxAmp = std::abs (pit->GetAmp ());
-          // Modified in order to subtract delay of first tap (maxTapDelay appears to be used later in code 
+          // Modified in order to subtract delay of first tap (maxTapDelay appears to be used later in code
           // as delay from first reception, not from TX time)
           maxTapDelay = pit->GetDelay () - pdp.GetTap(0).GetDelay();
         }
@@ -157,7 +157,7 @@
 
 
   double effRxPowerDb = rxPowerDb + KpToDb (csp);
-  //It appears to be just the first elements of the sum in Parrish paper, 
+  //It appears to be just the first elements of the sum in Parrish paper,
   // "System Design Considerations for Undersea Networks: Link and Multiple Access Protocols", eq. 14
   double isiUpa = DbToKp(rxPowerDb) * pdp.SumTapsFromMaxNc (ts + clearingTime, ts); // added DpToKp()
   UanTransducer::ArrivalList::const_iterator it = arrivalList.begin ();
@@ -493,17 +493,17 @@
 /*************** UanPhyGen definition *****************/
 UanPhyGen::UanPhyGen ()
   : UanPhy (),
-    m_state (IDLE),
-    m_channel (0),
-    m_transducer (0),
-    m_device (0),
-    m_mac (0),
-    m_txPwrDb (0),
-    m_rxThreshDb (0),
-    m_ccaThreshDb (0),
-    m_pktRx (0),
-    m_pktTx (0),
-    m_cleared (false)
+  m_state (IDLE),
+  m_channel (0),
+  m_transducer (0),
+  m_device (0),
+  m_mac (0),
+  m_txPwrDb (0),
+  m_rxThreshDb (0),
+  m_ccaThreshDb (0),
+  m_pktRx (0),
+  m_pktTx (0),
+  m_cleared (false)
 {
   m_pg = CreateObject<UniformRandomVariable> ();
 
@@ -741,6 +741,8 @@
       m_state = IDLE;
     }
   UpdatePowerConsumption (IDLE);
+
+  NotifyListenersTxEnd ();
 }
 
 void
@@ -1004,13 +1006,13 @@
 UanPhyGen::SetSleepMode (bool sleep )
 {
   if (sleep )
-  {
-    m_state = SLEEP;
-    if (!m_energyCallback.IsNull ())
-      {
-        m_energyCallback (SLEEP);
-      }
-  }
+    {
+      m_state = SLEEP;
+      if (!m_energyCallback.IsNull ())
+        {
+          m_energyCallback (SLEEP);
+        }
+    }
   else if (m_state == SLEEP)
     {
       if (GetInterferenceDb ((Ptr<Packet>) 0) > m_ccaThreshDb)
@@ -1155,6 +1157,16 @@
     }
 }
 
+void
+UanPhyGen::NotifyListenersTxEnd (void)
+{
+  ListenerList::const_iterator it = m_listeners.begin ();
+  for (; it != m_listeners.end (); it++)
+    {
+      (*it)->NotifyTxEnd ();
+    }
+}
+
 uint32_t
 UanPhyGen::GetNModes (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-phy-gen.h ns-3.34/src/uan/model/uan-phy-gen.h
--- ns-3.33/src/uan/model/uan-phy-gen.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-phy-gen.h	2021-07-14 10:31:07.000000000 -0700
@@ -215,10 +215,10 @@
  * clearing time between symbols transmitted on the same frequency.
  * This clearing time combats ISI from channel delay spread and also has
  * a byproduct of possibly reducing interference from other transmitted packets.
- * 
- * Thanks to Randall Plate for the latest model revision based on the following 
+ *
+ * Thanks to Randall Plate for the latest model revision based on the following
  * papers:
- * <ul> 
+ * <ul>
  * <li>Parrish, "System Design Considerations for Undersea Networks: Link and Multiple Access Protocols"
  * <li>Siderius, "Effects of Ocean Thermocline Variability on Noncoherent Underwater Acoustic Communications"
  * <li>Rao, "Channel Coding Techniques for Wireless Communications", ch 2
@@ -442,6 +442,10 @@
    * \param duration Duration of transmission.
    */
   void NotifyListenersTxStart (Time duration);
+  /**
+   * Call UanListener::NotifyTxEnd on all listeners.
+   */
+  void NotifyListenersTxEnd (void);
 
 protected:
   virtual void DoDispose ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/uan/model/uan-phy.h ns-3.34/src/uan/model/uan-phy.h
--- ns-3.33/src/uan/model/uan-phy.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/uan/model/uan-phy.h	2021-07-14 10:31:07.000000000 -0700
@@ -96,7 +96,7 @@
 
 protected:
   virtual void DoDispose (void);
-  
+
 };  // class UanPhyCalcSinr
 
 /**
@@ -147,7 +147,9 @@
 {
 public:
   /** Default destructor */
-  virtual ~UanPhyListener () { }
+  virtual ~UanPhyListener ()
+  {
+  }
   /** Called when UanPhy begins receiving packet. */
   virtual void NotifyRxStart (void) = 0;
   /** Called when UanPhy finishes receiving packet without error. */
@@ -164,7 +166,8 @@
    * \param duration Duration of transmission.
    */
   virtual void NotifyTxStart (Time duration) = 0;
-
+  /** Function called when Phy object finishes transmitting packet */
+  virtual void NotifyTxEnd (void) = 0;
 };  // class UanPhyListener
 
 /**
@@ -210,13 +213,12 @@
    * \param [in] sinr The SINR.
    * \param [in] mode The channel mode.
    */
-  typedef void (* TracedCallback)
-    (Ptr<const Packet> pkt, double sinr, UanTxMode mode);
+  typedef void (* TracedCallback)(Ptr<const Packet> pkt, double sinr, UanTxMode mode);
+
 
-  
   /**
-   * Set the DeviceEnergyModel callback for UanPhy device. 
-   * 
+   * Set the DeviceEnergyModel callback for UanPhy device.
+   *
    * \param callback The DeviceEnergyModel change state callback.
    */
   virtual void SetEnergyModelCallback (DeviceEnergyModel::ChangeStateCallback callback) = 0;
@@ -487,14 +489,14 @@
    */
   void NotifyRxDrop (Ptr<const Packet> packet);
 
- /**
-  * Assign a fixed random variable stream number to the random variables
-  * used by this model.  Return the number of streams (possibly zero) that
-  * have been assigned.
-  *
-  * \param stream First stream index to use.
-  * \return The number of stream indices assigned by this model.
-  */
+  /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by this model.  Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream First stream index to use.
+   * \return The number of stream indices assigned by this model.
+   */
   virtual int64_t AssignStreams (int64_t stream) = 0;
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/virtual-net-device/bindings/modulegen__gcc_ILP32.py ns-3.34/src/virtual-net-device/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/virtual-net-device/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/virtual-net-device/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
@@ -71,12 +71,16 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Mask [class]
     module.add_class('Ipv4Mask', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -350,8 +354,10 @@
     register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::TraceSourceAccessor >'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1166,6 +1172,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4Mask_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1379,6 +1397,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -1454,6 +1477,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -1474,6 +1509,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
